$!
$!  COMPILE.COM
$!
$!  This procedure compiles and links the source modules for the VERB
$!  utility using the local OpenVMS VAX system definitions (SYS.STB)
$!  or using the local base image (SYS$BASE_IMAGE), as appropriate.
$!
$!  To link the VERB utility from the provided object libraries -- this
$!  is used if you have no C compiler, for instance -- use LINK.COM.
$!
$!
$!  Expunge detritus.
$!
$ if f$search("verb_tmp.olb") .nes. "" then     DELETE verb_tmp.olb;*
$ if f$search("verb.hlp") .nes. "" then         DELETE verb.hlp;
$ if f$search("verb_utility.exe") .nes. "" then DELETE verb_utility.exe;*
$
$!  Build the VERB utility from source.
$!
$ call objectify verb.c
$ call objectify verb_command.c
$ call objectify verb_disallows.c
$ call objectify verb_entity.c
$ call objectify verb_find_entity.c
$ call objectify verb_file.c
$ call objectify verb_type.c
$ call objectify init_cli.c
$ call objectify verb_cld.cld
$ call objectify verb.rnh
$
$!  Invoke the common LINK procedure, and then clean up after it.
$!
$ @LINK 
$
$ if f$search("verb_tmp.olb") .nes. "" then DELETE verb_tmp.olb;*
$
$ Exit
$
$
$! Generate an object module from a source module.
$!
$objectify: subroutine
$ if f$search("verb_tmp.olb") .eqs. "" then library/create/object verb_tmp.olb
$ type = f$parse(p1,,,"TYPE") - "."
$ obj = f$parse(".OBJ;0",p1)
$ goto source_'type'
$source_c:
$ cc 'p1'
$!$ cc /debug/noopt 'p1'
$ library/insert verb_tmp.olb 'obj'
$ delete 'obj'
$ goto objected
$source_cld:
$ set command/object 'p1'
$ library/insert verb_tmp.olb 'obj'
$ delete 'obj'
$ goto objected
$source_rnh:
$ hlp = f$parse(".HLP;0",p1) - ";0"
$ runoff 'p1'
$objected:
$ endsubroutine
$
