$!  LINK.COM
$!
$!  This procedure links the pre-compiled object libraries for the VERB
$!  utility using the local OpenVMS VAX system definitions (SYS.STB)
$!  or using the local base image (SYS$BASE_IMAGE), as appropriate.
$!  If a locally-built VERB.OLB is found (as is the case if LINK.COM is
$!  called by COMPILE.COM), it will be used in preference.
$!
$!  To compile and link the VERB utility from the source modules, use
$!  the COMPILE.COM procedure -- not this command procedure.
$
$
$ cpu = f$getsyi("arch_type")
$
$ object_library = "Unknown or Unsupported Architecture"
$ linker_options = "Unknown or Unsupported Architecture"
$
$ if cpu .eq. 3
$ then
$   !  OpenVMS I64
$   object_library = "VERB_TMP.OLB"
$   if f$search(object_library) .eqs. "" then object_library = "[.IA-64]VERB.OLB"
$   linker_options = "/SYSEXE"
$!$   linker_options = "/SYSEXE/DEBUG"
$ endif
$
$ if cpu .eq. 2 
$ then
$   ! OpenVMS Alpha
$   object_library = "VERB_TMP.OLB"
$   if f$search(object_library) .eqs. "" then object_library = "[.ALPHA]VERB.OLB"
$   linker_options = "/SYSEXE"
$!$   linker_options = "/SYSEXE/DEBUG"
$ endif
$
$ if cpu .eq. 1 
$ then
$   ! OpenVMS VAX
$   object_library = "VERB_TMP.OLB"
$   if f$search(object_library) .eqs. "" then object_library = "[.VAX]VERB.OLB"
$   linker_options = ",SYS$SYSTEM:SYS.STB/SELECTIVE_SEARCH"
$!$   linker_options = ",SYS$SYSTEM:SYS.STB/SELECTIVE_SEARCH/DEBUG"
$ endif
$
$ link/notraceback/executable=verb_utility 'object_library' /include=verb/library ,'object_library' /library 'linker_options'
$
$ exit 1
