/* verb_type.c

	This module prints type blocks, then prints any entity
        blocks referenced by this type block.

        Modified 30-Apr-2003 Stephen Hoffman, OpenVMS Engineering
                $VMS_STATUS_SUCCESS, removed /STANDARD=VAXC
*/

#include <cli$routines.h>
#include <ssdef.h>
#include <stsdef.h>

#include "verb.h"

extern int verb_print_type(VectorBlock *table, CommandBlock *verb, TypeBlock *typ)
{
  EntityBlock *ent = TRO(table, typ->type_l_keywords);
  int sts;

  sts = verb_check_block(typ, BLOCK_K_TYPE);
  if (!$VMS_STATUS_SUCCESS( sts )) return sts;

  if (verb_entity_displayed(verb, (EntityBlock *)typ)) return SS$_NORMAL; /* already displayed */

  if (typ->type_w_name)
  {
    ascic *name = BRO(typ, typ->type_w_name);
    printf("define type %.*s\n", name->length, name->text);
  }
  else return SS$_ABORT;

  if (typ->type_w_prefix)
  {
    ascic *name = BRO(typ, typ->type_w_prefix);
    printf("   prefix %.*s\n", name->length, name->text);
  }

  if (typ->type_l_keywords)
  {
    sts = verb_print_entity(table, verb, ent);
    if (!$VMS_STATUS_SUCCESS( sts )) return sts;
    printf("\n");

    sts = verb_evaluate_entity(table, verb, ent);
    if (!$VMS_STATUS_SUCCESS( sts )) return sts;
  }
  else
  {
    printf("\n");
  }

  return SS$_NORMAL;
}
